'use strict';

var OcorrenciasController = angular.module('OcorrenciasController', []);

OcorrenciasController.controller('OcorrenciasCtrl', ['$scope', '$filter', 'Construcao', 'UploadApp', 'CacheApp',
  ($scope, $filter, Construcao, UploadApp, CacheApp) => {
    $scope.ocorrencias = [];

    $scope.construcao = CacheApp.getConstrucao();

    $scope.listaRelatorio = [
        { Id: 0, Descricao: 'Relatório de Ocorrências', Permissao: 'GET_RELATORIOOCORRENCIAS', Url: 'relatorioocorrencia' },
    ];

    $scope.excluirOcorrencia = (ocorrencia) => {
        $scope.msgBoxPergunta('Ocorrência da ' + $scope.construcao.TipoDescricao, 'Confirma exclusão da ocorrência?'
            , () => {
                Construcao.delOcorrencia(ocorrencia.Id,
                    (data) => {
                        $scope.getOcorrencias();
                    });
            }
            , () => {
            });
    }

    $scope.adicionarOcorrencia = () => {
        var idCount = $scope.ocorrencias.length;
        $scope.ocorrencias.unshift({
            Novo: true,
            Id: 0,
            IdConstrucao: $scope.construcao.Id,
            Descricao: '',
            Data: CacheApp.getData($filter("date")(Date.now(), 'yyyy-MM-ddT00:00:00Z')),
            IdCount: idCount
        });
    }

    $scope.cancelaOcorrencia = (ocorrencia) => {
        var idx = $scope.ocorrencias.indexOf(ocorrencia)
        $scope.ocorrencias.splice(idx, 1);
    }

    $scope.setOcorrencia = (ocorrencia) => {
        ocorrencia.Data = $filter("date")(ocorrencia.Data, 'yyyy-MM-ddT00:00:00Z')
        if (ocorrencia.file) {
            $scope.progress = 0;
            UploadApp.setOcorrencia(ocorrencia,
                (progress) => {
                    $scope.progress = progress;
                },
                (result) => {
                    $scope.progress = null;
                    $scope.getOcorrencias();
                },
                (error) => {})
        }
        else {
            Construcao.setOcorrencia(ocorrencia.Id, $scope.construcao.Id, ocorrencia.Descricao, ocorrencia.Data,
                (data) => {
                    $scope.getOcorrencias();
                });
        }
    }

    $scope.getOcorrencias = () => {
        Construcao.getOcorrencias($scope.construcao.Id,
            (data) => {
                $scope.ocorrencias = data.Instance;
                for (var i in $scope.ocorrencias) {
                    var dataHora = CacheApp.getData($filter("date")($scope.ocorrencias[i].Data, 'yyyy-MM-ddT00:00:00Z'));
                    $scope.ocorrencias[i].Data = CacheApp.getData(dataHora.getTime() + (24 * (60 * 60 * 1000)));
                }

            });
    }
    $scope.getOcorrencias();

    $scope.showImage = (src, alt) => {
        var css = {
            'maxWidth': $(window).width() - 100,
            'maxHeight': $(window).height() - 100
        };

        var $lightbox = $('#lightbox');
        $lightbox.find('.close').addClass('hidden');
        $lightbox.find('img').attr('src', src);
        $lightbox.find('img').attr('alt', alt);
        $lightbox.find('img').css(css);

        $lightbox.on('shown.bs.modal', (e) => {
            var $img = $lightbox.find('img');

            $lightbox.find('.modal-dialog').css({ 'width': $img.width() });
            $lightbox.find('.close').removeClass('hidden');
        });
    }


  }]);
